# Start a milestone (deprecated) POST https://app.unleash-instance.example.com/api/admin/projects/{project}/features/{featureName}/environments/{environment}/release_plans/{planId}/milestones/{milestoneId}/start **Enterprise feature** Starts a release plan milestone for a specific feature flag and environment. Deprecated, please use /release-plans/:planId/milestones/:milestoneId/start instead. Reference: https://docs.getunleash.io/api/old-start-milestone ## OpenAPI Specification ```yaml openapi: 3.1.1 info: title: Start a release plan milestone. version: endpoint_releaseTemplates.oldStartMilestone paths: /api/admin/projects/{project}/features/{featureName}/environments/{environment}/release_plans/{planId}/milestones/{milestoneId}/start: post: operationId: old-start-milestone summary: Start a release plan milestone. description: >- **Enterprise feature** Starts a release plan milestone for a specific feature flag and environment. Deprecated, please use /release-plans/:planId/milestones/:milestoneId/start instead. tags: - - subpackage_releaseTemplates parameters: - name: project in: path required: true schema: type: string - name: featureName in: path required: true schema: type: string - name: environment in: path required: true schema: type: string - name: planId in: path required: true schema: type: string - name: milestoneId in: path required: true schema: type: string - name: Authorization in: header description: Header authentication of the form `undefined ` required: true schema: type: string responses: '200': description: '#/components/schemas/releasePlanMilestoneSchema' content: application/json: schema: $ref: '#/components/schemas/releasePlanMilestoneSchema' '401': description: >- Authorization information is missing or invalid. Provide a valid API token as the `authorization` header, e.g. `authorization:*.*.my-admin-token`. content: {} '403': description: >- The provided user credentials are valid, but the user does not have the necessary permissions to perform this operation content: {} '404': description: The requested resource was not found. content: {} components: schemas: ReleasePlanMilestoneSchemaTransitionCondition: type: object properties: intervalMinutes: type: integer description: The interval in minutes before transitioning required: - intervalMinutes parametersSchema: type: object additionalProperties: type: string ConstraintSchemaOperator: type: string enum: - value: NOT_IN - value: IN - value: STR_ENDS_WITH - value: STR_STARTS_WITH - value: STR_CONTAINS - value: NUM_EQ - value: NUM_GT - value: NUM_GTE - value: NUM_LT - value: NUM_LTE - value: DATE_AFTER - value: DATE_BEFORE - value: SEMVER_EQ - value: SEMVER_GT - value: SEMVER_LT constraintSchema: type: object properties: contextName: type: string description: The name of the context field that this constraint should apply to. operator: $ref: '#/components/schemas/ConstraintSchemaOperator' description: >- The operator to use when evaluating this constraint. For more information about the various operators, refer to [the strategy constraint operator documentation](https://docs.getunleash.io/concepts/activation-strategies#constraint-operators). caseInsensitive: type: boolean default: false description: >- Whether the operator should be case sensitive or not. Defaults to `false` (being case sensitive). inverted: type: boolean default: false description: >- Whether the result should be negated or not. If `true`, will turn a `true` result into a `false` result and vice versa. values: type: array items: type: string description: >- The context values that should be used for constraint evaluation. Use this property instead of `value` for properties that accept multiple values. value: type: string description: >- The context value that should be used for constraint evaluation. Use this property instead of `values` for properties that only accept single values. required: - contextName - operator CreateStrategyVariantSchemaWeightType: type: string enum: - value: variable - value: fix CreateStrategyVariantSchemaPayloadType: type: string enum: - value: json - value: csv - value: string - value: number CreateStrategyVariantSchemaPayload: type: object properties: type: $ref: '#/components/schemas/CreateStrategyVariantSchemaPayloadType' description: >- The type of the value. Commonly used types are string, number, json and csv. value: type: string description: The actual value of payload required: - type - value createStrategyVariantSchema: type: object properties: name: type: string description: The variant name. Must be unique for this feature flag weight: type: integer description: >- The weight is the likelihood of any one user getting this variant. It is an integer between 0 and 1000. See the section on [variant weights](https://docs.getunleash.io/concepts/feature-flag-variants#variant-weight) for more information weightType: $ref: '#/components/schemas/CreateStrategyVariantSchemaWeightType' description: >- Set to `fix` if this variant must have exactly the weight allocated to it. If the type is `variable`, the weight will adjust so that the total weight of all variants adds up to 1000. Refer to the [variant weight documentation](https://docs.getunleash.io/concepts/feature-flag-variants#variant-weight). stickiness: type: string description: >- The [stickiness](https://docs.getunleash.io/concepts/feature-flag-variants#variant-stickiness) to use for distribution of this variant. Stickiness is how Unleash guarantees that the same user gets the same variant every time payload: $ref: '#/components/schemas/CreateStrategyVariantSchemaPayload' description: Extra data configured for this variant required: - name - weight - weightType - stickiness releasePlanMilestoneStrategySchema: type: object properties: id: type: string description: The milestone strategy's ID. Milestone strategy IDs are ulids. milestoneId: type: string description: The ID of the milestone that this strategy belongs to. sortOrder: type: number format: double description: The order of the strategy in the list title: type: - string - 'null' description: A descriptive title for the strategy strategyName: type: string description: The name of the strategy type parameters: $ref: '#/components/schemas/parametersSchema' description: An object containing the parameters for the strategy constraints: type: array items: $ref: '#/components/schemas/constraintSchema' description: >- A list of the constraints attached to the strategy. See https://docs.getunleash.io/concepts/activation-strategies#constraints variants: type: array items: $ref: '#/components/schemas/createStrategyVariantSchema' description: Strategy level variants segments: type: array items: type: number format: double description: Ids of segments to use for this strategy required: - id - milestoneId - sortOrder - strategyName releasePlanMilestoneSchema: type: object properties: id: type: string description: The milestone's ID. Milestone IDs are ulids. name: type: string description: The name of the milestone. sortOrder: type: integer description: The order of the milestone in the release plan. releasePlanDefinitionId: type: string description: The ID of the release plan/template that this milestone belongs to. startedAt: type: - string - 'null' format: date-time description: The date and time when the milestone was started. transitionCondition: oneOf: - $ref: >- #/components/schemas/ReleasePlanMilestoneSchemaTransitionCondition - type: 'null' description: The condition configuration for the transition progressionExecutedAt: type: - string - 'null' format: date-time description: The date and time when the milestone progression was executed. pausedAt: type: - string - 'null' format: date-time description: The date and time when the milestone was paused. strategies: type: array items: $ref: '#/components/schemas/releasePlanMilestoneStrategySchema' description: A list of strategies that are attached to this milestone. required: - id - name - sortOrder - releasePlanDefinitionId ``` ## SDK Code Examples ```python import requests url = "https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/release_plans/planId/milestones/milestoneId/start" headers = {"Authorization": ""} response = requests.post(url, headers=headers) print(response.json()) ``` ```javascript const url = 'https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/release_plans/planId/milestones/milestoneId/start'; const options = {method: 'POST', headers: {Authorization: ''}}; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "net/http" "io" ) func main() { url := "https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/release_plans/planId/milestones/milestoneId/start" req, _ := http.NewRequest("POST", url, nil) req.Header.Add("Authorization", "") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/release_plans/planId/milestones/milestoneId/start") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = '' response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/release_plans/planId/milestones/milestoneId/start") .header("Authorization", "") .asString(); ``` ```php request('POST', 'https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/release_plans/planId/milestones/milestoneId/start', [ 'headers' => [ 'Authorization' => '', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/release_plans/planId/milestones/milestoneId/start"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", ""); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = ["Authorization": ""] let request = NSMutableURLRequest(url: NSURL(string: "https://app.unleash-instance.example.com/api/admin/projects/project/features/featureName/environments/environment/release_plans/planId/milestones/milestoneId/start")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```